package xhttp3.internal.platform;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.List;
import javax.net.ssl.SSLParameters;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.X509TrustManager;
import xhttp3.Protocol;

final class Jdk9Platform extends Platform {
   final Method setProtocolMethod;
   final Method getProtocolMethod;

   public Jdk9Platform(Method setProtocolMethod, Method getProtocolMethod) {
      this.setProtocolMethod = setProtocolMethod;
      this.getProtocolMethod = getProtocolMethod;
   }

   public static Jdk9Platform buildIfSupported() {
      Class var10000;
      boolean var10001;
      try {
         var10000 = SSLParameters.class;
      } catch (NoSuchMethodException var7) {
         var10001 = false;
         return null;
      }

      String var9 = "setApplicationProtocols";

      Class[] var10002;
      try {
         var10002 = new Class[1];
      } catch (NoSuchMethodException var6) {
         var10001 = false;
         return null;
      }

      Class[] var10003 = var10002;
      byte var10004 = 0;

      Method var8;
      try {
         var10003[var10004] = String[].class;
         var8 = var10000.getMethod(var9, var10002);
      } catch (NoSuchMethodException var5) {
         var10001 = false;
         return null;
      }

      Method var0 = var8;

      try {
         var10000 = SSLSocket.class;
      } catch (NoSuchMethodException var4) {
         var10001 = false;
         return null;
      }

      var9 = "getApplicationProtocol";

      try {
         var8 = var10000.getMethod(var9);
      } catch (NoSuchMethodException var3) {
         var10001 = false;
         return null;
      }

      Method var1 = var8;

      try {
         return new Jdk9Platform(var0, var1);
      } catch (NoSuchMethodException var2) {
         var10001 = false;
         return null;
      }
   }

   public void configureTlsExtensions(SSLSocket sslSocket, String hostname, List<Protocol> protocols) {
      SSLSocket var10000;
      List var17;
      boolean var10001;
      SSLParameters var10002;
      try {
         var10000 = sslSocket;
         var17 = protocols;
         var10002 = sslSocket.getSSLParameters();
      } catch (IllegalAccessException var12) {
         var10001 = false;
         throw new AssertionError();
      } catch (InvocationTargetException var13) {
         var10001 = false;
         throw new AssertionError();
      }

      SSLParameters sslSocket1 = var10002;

      try {
         var17 = Platform.alpnProtocolNames(var17);
      } catch (IllegalAccessException var10) {
         var10001 = false;
         throw new AssertionError();
      } catch (InvocationTargetException var11) {
         var10001 = false;
         throw new AssertionError();
      }

      List hostname1 = var17;

      Method var18;
      SSLParameters var19;
      SSLParameters var10003;
      Object[] var10004;
      try {
         var19 = sslSocket1;
         var18 = this.setProtocolMethod;
         var10003 = sslSocket1;
         var10004 = new Object[1];
      } catch (IllegalAccessException var8) {
         var10001 = false;
         throw new AssertionError();
      } catch (InvocationTargetException var9) {
         var10001 = false;
         throw new AssertionError();
      }

      Object[] var10005 = var10004;
      List var10006 = hostname1;
      List var10007 = hostname1;
      byte var14 = 0;

      try {
         var10005[var14] = var10006.toArray(new String[var10007.size()]);
         var18.invoke(var10003, var10004);
      } catch (IllegalAccessException var6) {
         var10001 = false;
         throw new AssertionError();
      } catch (InvocationTargetException var7) {
         var10001 = false;
         throw new AssertionError();
      }

      try {
         var10000.setSSLParameters(var19);
         return;
      } catch (IllegalAccessException var4) {
         var10001 = false;
      } catch (InvocationTargetException var5) {
         var10001 = false;
      }

      throw new AssertionError();
   }

   public String getSelectedProtocol(SSLSocket param1) {
      // $FF: Couldn't be decompiled
   }

   public X509TrustManager trustManager(SSLSocketFactory sslSocketFactory) {
      throw new UnsupportedOperationException("clientBuilder.sslSocketFactory(SSLSocketFactory) not supported on JDK 9+");
   }
}
